/* @BABOLO (C)2000, 2001, 2002 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: getCGIparm.c,v 1.9 2002/07/03 02:10:32 babolo Exp $
 */
#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <stdio.h>
#include <time.h>
#include <err.h>
#include "getCGIparm.h"

extern char *optarg;
extern int optind;
extern int optopt;
extern int opterr;
extern int optreset;

u_char *myname, *errmsg, *errfile, *errform, *quot, *zero;
u_int32_t flags;
u_char *query_delimit;

void
usage(int ex)
{   int i;
    printf("getCGIparm " VERS "  " DATE " @BABOLO http://www.links.ru/~babolo/\n"
           "getCGIparm [Hnrptwxz][-c text][-f file][-q quoten] type [name]\n"
           "known types:"
          );
    for (i = 0; patterns[i].name; i++)
        printf(" %s", patterns[i].name);
    printf("\nknown quotens:");
    for (i = 0; quotens[i].name; i++)
        printf(" %s", quotens[i].name);
    printf("\n"
           " -a retry find nonempty parameter\n"
           " -c error text\n"
           " -f error message file\n"
           " -e error messages file\n"
           " -H use SERVER_PROTOCOL in addition to QUERY_STRING\n"
           " -n delete LF\n"
           " -r no CR\n"
           " -p pipe from stdin\n"
           " -t test mode - no output\n"
           " -w alternate &\n"
           " -x[x[x]] error levels\n"
           " -z text instead empty parameter\n"
          );
    exit(ex);
};

int
main(int argc, char **argv)
{
#define INBUF 1048576
    u_char *query = getenv("QUERY_STRING");
    u_char *proto = getenv("SERVER_PROTOCOL");
    u_char *unescaped, *p, *q;
    int i, j, ex = EX_OK;
    char ch;
#ifdef DEBUG
# if DEBUG > 1
    for (i = no; i < xx; i++)
    {   for (j = d0; j < dx; j++) printf(" %08X", automa[i][j]);
        printf("\n");
    }
# endif
#endif
#ifdef SPY
    {   FILE *spy;
        u_char *empty = "";
        int i;
# ifdef DEBUG
        spy = stderr;
# else
        spy = fopen(SPY, "a");
# endif
        if  (spy)
        {   for (i = 0; i < argc; i++)
                fprintf(spy, "%s~", argv[i]);
            fprintf( spy, "\nQUERY_STRING=%s~\nSERVER_PROTOCOL=%s~\n"
                   , query ? query : empty
                   , proto ? proto : empty
                   );
# ifndef DEBUG
            fclose(spy);
# endif
    }   }
#endif
    flags = 0;
    quot = NULL;
    errmsg = NULL;
    errfile = NULL;
    myname = *argv;
    query_delimit = NULL;
    while ((ch = getopt(argc, argv, "ac:e:f:hHnpq:rtw:xz:")) != EOF)
        switch (ch)
        {case 'a': flags |= RTRY;          break;
         case 'c': errmsg = optarg;        break;
         case 'e': errform = optarg;       break;
         case 'f': errfile = optarg;       break;
         case 'h': usage(ex);              break;
         case 'H': if  (strncmp(proto, "HTTP", 4))
                   {   q = malloc(strlen(query) + strlen(proto) + 2);
                       strcpy(q, query);
                       strcat(q, " ");
                       strcat(q, proto);
                       p = strstr(q, " HTTP");
                       if (p) *p = '\0';
                       query = q;
                   };                      break;
         case 'p': query = malloc(INBUF);
                   q = query; i = INBUF - 1;
                   while (feof(stdin) == 0 && i > 0)
                   {   j = fread(q, 1, i, stdin);
                       q += j; i -= j;
                   };
                   while (*--q < ' ') {};
                   *++q = '\0';            break;
         case 'q': quot = optarg;          break;
         case 'n': flags |= NOLF;          break;
         case 'r': flags |= NOCR;          break;
         case 't': flags |= OTST;          break;
         case 'w': query_delimit = optarg; break;
         case 'x': flags |= (flags << 1) & ERRORMASK;
                   flags |= DOER;
                                           break;
         case 'z': flags |= ZERO;
                   zero = optarg;
                                           break;
         default:  usage(EX_USAGE);
        }
    argc -= optind;
    argv += optind;

    if  (argc == 0) usage(EX_USAGE);
    if  (argc > 0 && !argv[0]) usage(EX_USAGE);
    if  (argc > 1 && !argv[1]) usage(EX_USAGE);
    if  (argc > 2) usage(EX_USAGE);
    if  (!query) query = "";
    unescaped = malloc(strlen(query) * (query_delimit ? strlen(query_delimit) : 1) + 1);
    if  (!unescaped)                                           err(EX_TEMPFAIL, "%s: malloc:", myname);
    p = unescaped;
    i = 0;

    for (;;)
    {   ex = pass1(flags, &query, argv[1], p);
        if  (!ex && *query++ == '&')
        {   if  (query_delimit)
                p = index(strcat(unescaped, query_delimit), '\0');
            else if (flags & RTRY && !*unescaped) i++;
            else break;
        }else break;
    }

    if  (ex && i)
    {   *unescaped = '\0';
        ex = EX_OK;
    }

    if  (!ex)
    {   ex = pass2(flags, argv[0], unescaped);
        if  (!ex)
        {   ex = pass3(flags, quot, &unescaped);
            if  (!ex && flags & NONL && !*unescaped) ex = EX_DATAERR;
        }else if (~flags & MATC)
        {   *unescaped = '\0';
            ex = EX_OK;
        }
    }else if (~flags & DOER) ex = EX_OK;

    if  (ex) pass4(flags, argv[0], errmsg, errfile, errform);
    else if (~flags & OTST) printf("%s", (flags & ZERO && !*unescaped) ? zero : unescaped);

#ifdef SPY
    {   FILE *spy;
        time_t t;
# ifdef DEBUG
        spy = stderr;
# else
        spy = fopen(SPY, "a");
# endif
        if  (spy)
        {   t = time(NULL);
            fprintf( spy, "%04X, %2d, OUT=%s~\n%s\n"
                   , flags, ex, (flags & ZERO && !*unescaped) ? zero : unescaped, ctime(&t)
                   );
# ifndef DEBUG
            fclose(spy);
# endif
    }   }
#endif
    exit(ex);
}
