/* @BABOLO (C)2000, 2001, 2002 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: pass2.c,v 1.3 2002/07/03 02:10:33 babolo Exp $
 */
#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#ifdef DEBUG
#include <stdio.h>
#endif
#include "getCGIparm.h"

enum classes koi[256] =
{no,no,no,no ,no,no,no,no ,no,ok,ok,no ,no,ok,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok

,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,no,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,no

,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,ok ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,ok ,no,no,no,no ,no,no,no,no ,no,no,no,no

,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
};

/*
 *   
 *     .
 *    .
 */

int test_set(u_char *pattern, u_char *query)
{   u_char ctest[256], c, *q = pattern, *p = query;
    int rev = (*++q == '^');

    bzero(ctest, 256 * sizeof(u_char));
    if  (rev) ++q;
    if  (*q == '-') ctest[*q++] = 1;
    for (c = 0; *q; c = *q++)
    {   switch (*q)
        {case '-':
            q++;
            while (c < *q) ctest[++c] = 1;
            break;
         case '\\':
            ctest[++*q] = 1;
            break;
         case ']':
            q = index(q, '\0');
            break;
         default:
            ctest[*q] = 1;
            break;
        }
        if  (!*q) break;
    }
    while (*p) if (ctest[*p++] == rev) return(1);
    return(0);
};

int test_inetnet(u_char *pattern, u_char *query)
{   u_char *p = query;
    int i0, i;

    /* Look for 4 integers 0..255 */
    for (i0 = 0; i0 < 4; i0++)
    {   if  (*p < '0' || *p > '9') return(1);  /* Number begin - must be digit */
        i = (int)strtol(p, (char**)&p, 0);
        if  (i < 0 || i > 255) return(1);      /* 0..255 */
        if  (i0 < 3 && *p++ != '.') return(1); /* Dot if not 4 clause */
    }
    if  (*p)
    {   if  (*p++ != '/') return(1);           /* Must be / if not the end */
        if  (*p < '0' || *p > '9') return(1);  /* Number begin - must be digit */
        i = (int)strtol(p, (char**)&p, 0);
        if  (i < 0 || i > 32) return(1);       /* 0..32 */
    }
    return(!(!*p));
};

int test_date(u_char *pattern, u_char *query)
{   u_char *p = query;
    int i;

    if  (!(*p >= '0' && *p <= '9')) return(1);
    i = (int)strtol(p, (char**)&p, 10);
    if  (!(i >= 1900 && i <= 2147)) return(1);
    if  (*p++ != '-') return(1);
    if  (!(*p >= '0' && *p <= '9')) return(1);
    i = (int)strtol(p, (char**)&p, 10);
    if  (!(i >= 1 && i <= 12)) return(1);
    if  (*p++ != '-') return(1);
    if  (!(*p >= '0' && *p <= '9')) return(1);
    i = (int)strtol(p, (char**)&p, 10);
    if  (!(i >= 1 && i <= 31)) return(1);
    return(0);
};

int test_macaddr(u_char *pattern, u_char *query)
{   u_char c, *p = query;
    int i0, i1;

    for (i0 = 0; i0 < 6; i0++)
    {   for (i1 = 0; i1 < 2; i1++)
        {   c = *p++;
            if  (! (  (c >= '0' && c <= '9')
                   || (c >= 'a' && c <= 'f')
                   || (c >= 'A' && c <= 'F')
                )  ) return(1);
        }
        if  (i0 < 5 && *p++ != ':') return(1);
    }
    return(!(!*p));
};

int test_inetaddr(u_char *pattern, u_char *query)
{   u_char *p = query;
    int i0, i;

    for (i0 = 0; i0 < 4; i0++)
    {   if  (!(*p >= '0' && *p <= '9')) return(1);
        if  (i0 < 3 && *p == '0' && *(p + 1) != '.') return(1);
        i = (int)strtol(p, (char**)&p, 10);
        if  (!(i >= 0 && i <= 255)) return(1);
        if  (i0 < 3 && *p++ != '.') return(1);
    }
    return(!(!*p));
};

int test_koi8(u_char *pattern, u_char *query)
{   u_char *p = query;

    while (*p) if (!koi[*p++]) return(1);
    return(0);
};

int test_eq(u_char *pattern, u_char *query)
{   return(strcmp(++pattern, query));
};

int dummy(u_char *pattern, u_char *query)
{   return(0);
};

/*
 *    .
 *        :
 */

struct patterns patterns[] =
{ {"[list]"  , 1, test_set      }
, {"any"     , 0, dummy         }
, {"8"    , 0, test_koi8     }
, {"8"    , 0, test_koi8     }
, {"macaddr" , 0, test_macaddr  }
, {"inetaddr", 0, test_inetaddr }
, {"inetnet" , 0, test_inetnet  }
, {"=string" , 1, test_eq       }
, {"date"    , 0, test_date     }
, {NULL      , 0, NULL          }
};

int
pass2( u_int32_t flags
     , u_char *q
     , u_char *unescaped
     )
{   int i, ex;

#ifdef DEBUG
    fprintf(stderr, "%04X pass2 ~%s~%s~\n", flags, q, unescaped);
#endif
    if  (!q || !*q || !unescaped)
        ex = EX_SOFTWARE;
    else if  (!*unescaped)
    {    ex = (flags & NONL) ? EX_DATAERR : EX_OK;
    }else
    {   ex = EX_USAGE;
        for (i = 0; patterns[i].name; i++)
        {   if  ( patterns[i].namelen
                ? !strncmp(patterns[i].name, q, patterns[i].namelen)
                : !strcmp(patterns[i].name, q)
                )
            {   ex = (patterns[i].test_proc)(q, unescaped) ? EX_DATAERR : EX_OK;
                break;
    }   }   }
    return(ex);
}
