/* @BABOLO (C)2000, 2001, 2002 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: pass3.c,v 1.3 2002/04/27 04:51:09 babolo Exp $
 */
#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "getCGIparm.h"

int
quote_literal(u_char *pattern, u_char *query, u_char **result)
{   char *p;
    *result = malloc(strlen(query) * 2 + 1);
    p = *result;
    for (; *query; query++)
    {   switch(*query)
        {case '\'': case '\\': *p++ = *query; *p++ = *query; break;
         default: *p++ = *query;
    }   }
    *p++ = '\0';
    return(EX_OK);
};

int
quote_ident(u_char *pattern, u_char *query, u_char **result)
{   char *p;
    *result = malloc(strlen(query) * 2 + 1);
    p = *result;
    for (; *query; query++)
    {   switch(*query)
        {case '\"': case '\\': *p++ = *query; *p++ = *query; break;
         default: *p++ = *query;
    }   }
    *p++ = '\0';
    return(EX_OK);
};

int
single_quotes(u_char *pattern, u_char *query, u_char **result)
{   char *p;
    *result = malloc(strlen(query) + 3);
    p = *result;
    strcpy(p, "\'");
    strcat(p, query);
    strcat(p, "\'");
    return(EX_OK);
};

int
double_quotes(u_char *pattern, u_char *query, u_char **result)
{   char *p;
    *result = malloc(strlen(query) + 3);
    p = *result;
    strcpy(p, "\"");
    strcat(p, query);
    strcat(p, "\"");
    return(EX_OK);
};

struct quotens quotens[] =
{ {"psql" , 0, quote_literal}
, {"psqi" , 0, quote_ident  }
, {"sq"   , 0, single_quotes}
, {"dq"   , 0, double_quotes}
, {NULL   , 0, NULL         }
};

int
pass3( u_int32_t flags
     , u_char *q
     , u_char **unescaped
     )
{   int i, ex;
    u_char *r;

#ifdef DEBUG
    fprintf(stderr, "%04X pass3 ~%s~%s~\n", flags, q, *unescaped);
#endif
    ex = EX_OK;
    if  (!unescaped)
        ex = EX_SOFTWARE;
    else if (!q || !*q) ex = EX_OK;
    else if (~flags & ZERO || **unescaped)
    {   u_char *p = NULL;

        while (!ex && q && *q)
        {   ex = EX_USAGE;
            r = strsep(&q, "/");
            for (i = 0; quotens[i].name; i++)
            {   if  ( quotens[i].namelen
                    ? !strncmp(quotens[i].name, r, quotens[i].namelen)
                    : !strcmp(quotens[i].name, r)
                    )
                {   if  (!(ex = (quotens[i].test_proc)(r, *unescaped, &p) ? EX_DATAERR : EX_OK))
                    {   if  (*unescaped != p)
                        {   free(*unescaped);
                            *unescaped = p;
#ifdef DEBUG
                            fprintf(stderr, "pass3 NEW=%s~\n", p);
                        }else
                        {   fprintf(stderr, "pass3 OLD=%s~\n", p);
#endif
                    }   }
                    break;
    }   }   }   }
    return(ex);
}
